Update a subscription
Use this call to make the following kinds of changes to a subscription:
- Add a note
- Change the renewal term or auto-renewal flag
- Change the term length or change between evergreen and termed
- Add a new product rate plan
- Remove an existing subscription rate plan
- Change the quantity or price of an existing subscription rate plan
- Change rate plans - to replace the existing rate plans in a subscription with other rate plans. Changing rate plans is currently not supported for the Billing - Revenue Integration feature. When Billing - Revenue Integration is enabled, changing rate plans will no longer be applicable in Zuora Billing.
Notes:
-
The “Update a subscription” call creates a new subscription object that has a new version number and to which the subscription changes are applied. The new subscription object has the same subscription name but a new, different, subscription ID. The
Statusfield of the new subscription object will be set toActiveunless the change applied was a cancelation or suspension in which case the status reflects that. TheStatusfield of the originating subscription object changes fromActivetoExpired. A status ofExpireddoes not imply that the subscription itself has expired or ended, merely that this subscription object is no longer the most recent. -
In one request, this call can make:
- Up to 9 combined add, update, and remove changes
- No more than 1 change to terms & conditions
-
Updates are performed in the following sequence:
- First change the notes on the existing subscription, if requested.
- Then change the terms and conditions, if requested.
- Then perform the remaining amendments based upon the effective dates specified. If multiple amendments have the same contract-effective dates, then execute adds before updates, and updates before removes.
-
The update operation is atomic. If any of the updates fails, the entire operation is rolled back.
-
The response of the Update Subscription call is based on the REST API minor version you set in the request header. The response structure might be different if you use different minor version numbers.
-
If you have the Invoice Settlement feature enabled, it is best practice to set the
Zuora-Versionparameter to211.0or later available versions. Otherwise, an error occurs.
Override a Tiered Price
There are two ways you override a tiered price:
- Override a specific tier number. For example:
tiers[{tier:1,price:8},{tier:2,price:6}] - Override the entire tier structure. For example:
tiers[{tier:1,price:8,startingUnit:1,endingUnit:100,priceFormat:"FlatFee"}, {tier:2,price:6,startingUnit:101,priceFormat:"FlatFee"}]
If you just override a specific tier, do not include the startingUnit field in the request.
Authentication
Use Bearer {{token}} in the Authorization header for authentication.
Path parameters
Subscription number or ID. ID can be the latest version or any history version of ID.
- To make sure you update the last version of the subscription, use one of the following operations to retrieve the last version of ID:
- List subscriptions by account key
- Retrieve a subscription by key by using the subscription number as the subscription-key
- If you want to use any history version of ID, the
STABLE_ID_PUBLIC_APIpermission must be enabled. Submit a request at Zuora Global Support to enable the permission. To retrieve a history version of ID, use the Retrieve a subscription by key and version operation.
Headers
Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.
Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').
An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.
The minor API version.
For a list of available minor versions, see API upgrades.
Request
The priority order to apply credit memos and/or unapplied payments to an invoice. Possible item values are: CreditMemo, UnappliedPayment.
Note:
- This field is valid only if the
applyCreditfield is set totrue. - If no value is specified for this field, the default priority order is used, [“CreditMemo”, “UnappliedPayment”], to apply credit memos first and then apply unapplied payments.
- If only one item is specified, only the items of the spedified type are applied to invoices. For example, if the value is
["CreditMemo"], only credit memos are used to apply to invoices.
Whether to automatically apply credit memos or unapplied payments, or both to an invoice.
If the value is true, the credit memo or unapplied payment, or both will be automatically applied to the invoice. If no value is specified or the value is false, no action is taken.
Note: This field is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.
Whether to automatically apply a credit balance to an invoice.
If the value is true, the credit balance is applied to the invoice. If the value is false, no action is taken.
To view the credit balance adjustment, retrieve the details of the invoice using the Get Invoices method.
Prerequisite: invoice must be true.
Note:
- If you are using the field
invoiceCollectrather than the fieldinvoice, theinvoiceCollectvalue must betrue. - This field is deprecated if you have the Invoice Settlement feature enabled.
If true, this subscription automatically renews at the end of the subscription term. Default is false.
The booking date that you want to set for the contract when you change the termType field of the subscription and as a result get a new version of subscription created. The booking date of an amendment is the equivalent of the order date of an order. This field must be in the yyyy-mm-dd format. The default value is the current date when you make the API call.
Use this field to change one or more rate plans - to replace the existing rate plans in a subscription with other rate plans.
Note: Changing rate plans is currently not supported for the Billing - Revenue Integration feature. When Billing - Revenue Integration is enabled, changing rate plans will no longer be applicable in Zuora Billing.
Collects an automatic payment for a subscription. The collection generated in this operation is only for this subscription, not for the entire customer account.
If the value is true, the automatic payment is collected. If the value is false, no action is taken.
Prerequisite: The invoice or runBilling field must be true.
Note: This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 196.0 or a later available version.
The length of the period for the current subscription term. If termType is TERMED, this field is required and must be greater than 0. If termType is EVERGREEN, this value is ignored.
The period type for the current subscription term.
This field is used with the CurrentTerm field to specify the current subscription term.
Values are:
Month(default)YearDayWeek
The date of the billing document, in yyyy-mm-dd format. It represents the invoice date for invoices, credit memo date for credit memos, and debit memo date for debit memos.
- If this field is specified, the specified date is used as the billing document date.
- If this field is not specified, the date specified in the
targetDateis used as the billing document date.
An enum field on the Subscription object to indicate the name of a third-party store. This field is used to represent subscriptions created through third-party stores.
Specifies whether to include draft invoice items in subscription previews. Values are:
true(default). Includes draft invoice items in the preview result.false. Excludes draft invoice items in the preview result.
Note: This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 207.0 or a later available version.
Separates a single subscription from other subscriptions and invoices the charge independently.
If the value is true, the subscription is billed separately from other subscriptions. If the value is false, the subscription is included with other subscriptions in the account invoice.
The default value is false.
Prerequisite: The default subscription setting Enable Subscriptions to be Invoiced Separately must be set to Yes.
If true the update is made in preview mode. The default setting is false.
The type of preview you will receive.
Note: If your API minor version is earlier than 206.0 or you specify the Zuora-Version header for this request to 206.0 or earlier, the following values are supported for the previewType field:
InvoiceItem(default)ChargeMetricsInvoiceItemChargeMetrics
Specifies whether a termed subscription will remain TERMED or change to EVERGREEN when it is renewed.
Values are:
RENEW_WITH_SPECIFIC_TERM(default)RENEW_TO_EVERGREEN
The length of the period for the subscription renewal term. Default is 0.
The period type for the subscription renewal term.
This field is used with the renewalTerm field to specify the subscription renewal term.
Values are:
Month(default)YearDayWeek
Creates an invoice for a subscription. If you have the Invoice Settlement feature enabled, a credit memo might also be created based on the invoice and credit memo generation rule.
The billing documents generated in this operation is only for this subscription, not for the entire customer account.
This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 211.0 or a later available version.
Possible values:
-
true: An invoice is created. If you have the Invoice Settlement feature enabled, a credit memo might also be created. -
false: No invoice is created.
Date through which to calculate charges if an invoice or a credit memo is generated, as yyyy-mm-dd. Default is current date.
Note: The credit memo is only available if you have the Invoice Settlement feature enabled.
This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 211.0 or a later available version.
Date the subscription term begins, as yyyy-mm-dd. If this is a renewal subscription, this date is different from the subscription start date.
Possible values are: TERMED, EVERGREEN.
ID of the corresponding object in NetSuite. Only available if you have installed the Zuora Connector for NetSuite.
Status of the subscription’s synchronization with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.
The NetSuite project that the subscription was created from. Only available if you have installed the Zuora Connector for NetSuite.
The NetSuite sales order than the subscription was created from. Only available if you have installed the Zuora Connector for NetSuite.
Date when the subscription was synchronized with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.
Response headers
This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
application/jsonapplication/xmltext/htmltext/csvtext/plain
The request limit quota for the time window closest to exhaustion. See rate limits for more information.
The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.
The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.
The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.
For more information, see Concurrent request limits.
The total number of the permitted concurrent requests.
For more information, see Concurrent request limits.
The remaining number of the permitted concurrent requests.
For more information, see Concurrent request limits.
Response
Container for charge metrics. This field is available only if the preview field in the request body is true.
Container for credit memos. This field is available only if the preview field in the request body is true.
Note: This container is only available if you set the Zuora REST API minor version to 207.0 or later available versions in the request header, and you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.
The credit memo ID. This field is available only if the preview field in the request body is false and a credit memo is generated during the update.
Note: This container is only available if you set the Zuora REST API minor version to 207.0 or later available versions in the request header, and you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.
Container for invoices. This field is available only if the preview field in the request body is true.
Note: This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 207.0 or
a later available version. Also, the response structure is changed and the following invoice related response fields are moved to this invoice container:
- amount
- amountWithoutTax
- taxAmount
- invoiceItems
- targetDate
The ID of the generated invoice.
This field is available only if the preview field in the request body is false and an invoice is generated during the update.
Container for invoice items. This field is available only if the preview field in the request body is true.
Returns true if the request was processed successfully.
Date through which to calculate charges if an invoice is generated, as yyyy-mm-dd. Default is current date. This field is available only if the preview field in the request body is true.
Note: This field is only available if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 207.0 or a later available version.
Tax amount on the invoice. This field is available only if the preview field in the request body is true.